unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, RVTable, RVScroll, RichView, ComCtrls, StdCtrls, RVStyle;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    RichEdit1: TRichEdit;
    RichView1: TRichView;
    RVStyle1: TRVStyle;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var Stream: TStringStream;
begin
  Memo1.Lines.Text := 'First Cell (text)';

  Stream := TStringStream.Create('{\rtf1\ansi \b Second cell\b0  (rich text)\par}');
  try
    RichEdit1.Lines.LoadFromStream(Stream);
  finally
    Stream.Free;
  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
var table: TRVTableItemInfo;
    Stream: TMemoryStream;
begin
  RichView1.Clear;
  RichView1.DeleteUnusedStyles(True, True, True);
  RVStyle1.TextStyles[0].Assign(Memo1.Font); // default font (for plain text from Memo1)

  table := TRVTableItemInfo.CreateEx(1, 2, RichView1.RVData);
  table.BorderWidth := 2;
  table.CellBorderWidth := 1;
  table.Color := clNone;
  table.CellPadding := 4;
  table.Cells[0,0].BestWidth := -33; // 1/3 of the table
  table.Cells[0,1].BestWidth := -67; // 2/3 of the table

  // Memo1 --> Cells[0,0]
  table.Cells[0,0].Clear;
  table.Cells[0,0].AddTextNLA(Memo1.Lines.Text, 0, 0, 0);

  // RichEdit1 --> Cells[0,1]
  table.Cells[0,1].Clear;
  Stream := TMemoryStream.Create;
  try
    RichEdit1.Lines.SaveToStream(Stream);
    Stream.Position := 0;
    table.Cells[0,1].LoadRTFFromStream(Stream);
  finally
    Stream.Free;
  end;


  RichView1.AddItem('', table);
  RichView1.Format;
end;


end.
